/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC 1T Series MCU Demo Programme -------------------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966 ------------------------*/
/* --- Web: www.STCMCU.com --------------------------------------------*/
/* --- Web: www.STCMCUDATA.com  ---------------------------------------*/
/* --- QQ:  800003751 -------------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ            */
/*---------------------------------------------------------------------*/

#include	"APP_CAN.h"
#include	"STC32G_CAN.h"
#include	"STC32G_GPIO.h"
#include	"STC32G_NVIC.h"
#include	"STC32G_Switch.h"

/*************   ˵   ***************

CAN1CAN2ͬʱʹշ.

DCANһ֧CAN2.0BЭĹܵԪ

յһ׼֡, CAN ID1, ԭͳȥ.

MCUÿӴCAN1CAN2һ̶֡.

Ĭϲ500KHz, û޸.

ʱ, ѡʱ 24MHz (û"config.h"޸Ƶ).

******************************************/

//========================================================================
//                               س	
//========================================================================

#define	SetExtendedFrame	0    //0: ׼֡ͨ; 1: չ֡ͨ

//========================================================================
//                               ر
//========================================================================

u32 CAN1_ID;
u32 CAN2_ID;
u8 RX1_BUF[8];
u8 TX1_BUF[8];
u8 RX2_BUF[8];
u8 TX2_BUF[8];

//========================================================================
//                               غ
//========================================================================


//========================================================================
//                            ⲿͱ
//========================================================================

extern bit B_Can1Read;     //CAN յݱ־
extern bit B_Can2Read;     //CAN յݱ־
extern bit B_Can1Send;     //CAN ݱ־
extern bit B_Can2Send;     //CAN ݱ־

extern u16 msecond;

/********************** ȴ **********************/
void WaitCan1Send(u8 i)
{
	 while((--i) && (B_Can1Send));
}

void WaitCan2Send(u8 i)
{
	 while((--i) && (B_Can2Send));
}

//========================================================================
// : CAN_init
// : ûʼ.
// : None.
// : None.
// 汾: V1.0, 2022-03-27
//========================================================================
void CAN_init(void)
{
	CAN_InitTypeDef	CAN_InitStructure;					//ṹ

	CAN_InitStructure.CAN_Enable = ENABLE;		//CANʹ   ENABLEDISABLE
	CAN_InitStructure.CAN_IMR    = CAN_ALLIM;	//CANжϼĴ 	CAN_DOIM,CAN_BEIM,CAN_TIM,CAN_RIM,CAN_EPIM,CAN_EWIM,CAN_ALIM,CAN_ALLIM,DISABLE
	CAN_InitStructure.CAN_SJW    = 0;					//ͬԾ  0~3
	CAN_InitStructure.CAN_SAM    = 0;					//ߵƽ  0:1; 1:3

	//CAN߲=Fclk/((1+(TSG1+1)+(TSG2+1))*(BRP+1)*2)
	CAN_InitStructure.CAN_TSG1   = 2;					//ͬ1       0~15
	CAN_InitStructure.CAN_TSG2   = 1;					//ͬ2       1~7 (TSG2 Ϊ0)
	CAN_InitStructure.CAN_BRP    = 3;					//ʷƵϵ    0~63
	//24000000/((1+3+2)*4*2)=500KHz

	CAN_InitStructure.CAN_ACR0    = 0x00;			//մĴ 0~0xFF
	CAN_InitStructure.CAN_ACR1    = 0x00;
	CAN_InitStructure.CAN_ACR2    = 0x00;
	CAN_InitStructure.CAN_ACR3    = 0x00;
	CAN_InitStructure.CAN_AMR0    = 0xff;			//μĴ 0~0xFF
	CAN_InitStructure.CAN_AMR1    = 0xff;
	CAN_InitStructure.CAN_AMR2    = 0xff;
	CAN_InitStructure.CAN_AMR3    = 0xff;
	CAN_Inilize(CAN1,&CAN_InitStructure);			//CAN1 ʼ
	CAN_Inilize(CAN2,&CAN_InitStructure);			//CAN2 ʼ
	
	NVIC_CAN_Init(CAN1,ENABLE,Priority_1);		//жʹ, CAN1/CAN2; ENABLE/DISABLE; ȼ(͵) Priority_0,Priority_1,Priority_2,Priority_3
	NVIC_CAN_Init(CAN2,ENABLE,Priority_1);		//жʹ, CAN1/CAN2; ENABLE/DISABLE; ȼ(͵) Priority_0,Priority_1,Priority_2,Priority_3
	
	P0_MODE_IO_PU(GPIO_Pin_LOW);		//P0.0~P0.3 Ϊ׼˫

	CAN1_SW(CAN1_P00_P01);				//CAN1_P00_P01,CAN1_P50_P51,CAN1_P42_P45,CAN1_P70_P71
	CAN2_SW(CAN2_P02_P03);				//CAN2_P02_P03,CAN2_P52_P53,CAN2_P46_P47,CAN2_P72_P73

	//====ʼ=====
	CAN1_ID = 0x01234567;
	TX1_BUF[0] = 0x11;
	TX1_BUF[1] = 0x12;
	TX1_BUF[2] = 0x13;
	TX1_BUF[3] = 0x14;
	TX1_BUF[4] = 0x15;
	TX1_BUF[5] = 0x16;
	TX1_BUF[6] = 0x17;
	TX1_BUF[7] = 0x18;
	
	CAN2_ID = 0x03456789;
	TX2_BUF[0] = 0x21;
	TX2_BUF[1] = 0x22;
	TX2_BUF[2] = 0x23;
	TX2_BUF[3] = 0x24;
	TX2_BUF[4] = 0x25;
	TX2_BUF[5] = 0x26;
	TX2_BUF[6] = 0x27;
	TX2_BUF[7] = 0x28;
}

//========================================================================
// : Sample_CAN
// : ûӦó.
// : None.
// : None.
// 汾: V1.0, 2022-03-27
//========================================================================
void Sample_CAN(void)
{
	u8 sr;
	u8 buffer[16];

		//------------------CAN1ģ-----------------------
	if(++msecond >= 1000)   //1뵽
	{
		msecond = 0;

		CANSEL = CAN1;		//ѡCAN1ģ
		sr = CanReadReg(SR);

		if((sr & 0x88)==0x80)		//տУBUFFER֡
		{
			CanReadFifo(buffer);  //ȡBUFFER
		}
		
		if(sr & 0x01)		//жǷ BS:BUS-OFF״̬
		{
			CANAR = MR;
			CANDR &= ~0x04;  // Reset Mode, BUS-OFF״̬˳
		}
		else
		{
			B_Can1Send = 1;
#if(SetExtendedFrame)
			CanSendExtendedFrame(CAN1_ID,TX1_BUF);
#else
			CanSendStandardFrame((u16)CAN1_ID,TX1_BUF);
#endif
			WaitCan1Send(50);    //ȴCAN1
		}

		//------------------CAN2ģ-----------------------
		CANSEL = CAN2;		//ѡCAN2ģ
		sr = CanReadReg(SR);

		if((sr & 0x88)==0x80)		//տУBUFFER֡
		{
			CanReadFifo(buffer);  //ȡBUFFER
		}
		
		if(sr & 0x01)		//жǷ BS:BUS-OFF״̬
		{
			CANAR = MR;
			CANDR &= ~0x04;  // Reset Mode, BUS-OFF״̬˳
		}
		else
		{
			B_Can2Send = 1;
#if(SetExtendedFrame)
			CanSendExtendedFrame(CAN2_ID,TX2_BUF);
#else
			CanSendStandardFrame((u16)CAN2_ID,TX2_BUF);
#endif
			WaitCan2Send(50);    //ȴCAN2
		}
	}

	if(B_Can1Read)
	{
		B_Can1Read = 0;
		
		CANSEL = CAN1;		//ѡCAN1ģ
#if(SetExtendedFrame)
		CAN1_ID = CanReadExtendedFrame(RX1_BUF);	//CAN
		CanSendExtendedFrame(CAN1_ID+1,RX1_BUF);	//CAN
#else
		CAN1_ID = CanReadStandardFrame(RX1_BUF);	//CAN
		CanSendStandardFrame(CAN1_ID+1,RX1_BUF);	//CAN
#endif
	}

	if(B_Can2Read)
	{
		B_Can2Read = 0;
		
		CANSEL = CAN2;		//ѡCAN2ģ
#if(SetExtendedFrame)
		CAN2_ID = CanReadExtendedFrame(RX2_BUF);	//CAN
		CanSendExtendedFrame(CAN2_ID+1,RX2_BUF);	//CAN
#else
		CAN2_ID = CanReadStandardFrame(RX2_BUF);	//CAN
		CanSendStandardFrame(CAN2_ID+1,RX2_BUF);	//CAN
#endif
	}
}

